=== debian/control ===
Source: openscad
Priority: optional
Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
Build-Depends:
    debhelper (>= 7.0.50~),
    qt4-qmake (>=4.4),
    libcgal-dev (>=3.6),
    libopencsg-dev (>=1.3.0),
    libeigen2-dev (>= 2.0.13),
    bison (>= 2.4),
    flex (>=2.5.35),
    libqt4-opengl-dev,
    libglew-dev (>= 1.5.4) | libglew1.6-dev | libglew1.5-dev (>= 1.5.4),
    libgmp-dev | libgmp10-dev | libgmp3-dev,
    libmpfr-dev,
    imagemagick,
    python,
    cmake,
    libboost-dev (>= 1.46.0),
    chrpath,
    pkg-config
Standards-Version: 3.9.3
Section: graphics
DM-Upload-Allowed: yes
Homepage: http://openscad.org/
Vcs-Browser: http://gitorious.org/openscad-debian/openscad/commits/debian
Vcs-git: git://gitorious.org/openscad-debian/openscad.git/

Package: openscad
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
# not in archive yet
# Recommends:
#     openscad-mcad (>= 2011.12)
Suggests:
    meshlab,
    geomview,
    librecad
Description: script file based graphical CAD environment
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 OpenSCAD is not an interactive modeller. Instead it is something like a
 3D-compiler that reads in a script file that describes the object and renders
 the 3D model from this script. This gives the designer full control over the
 modelling process and enables him to easily change any step in the modelling
 process or make designes that are defined by configurable parameters.

Package: openscad-testing
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    openscad-testing-data,
    python,
    python-argparse,
    cmake
Description: script file based graphical CAD environment (test suite)
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 This package contains all programs required to run the test suites.

Package: openscad-testing-data
Architecture: all
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
# the examples, which are shipped in openscad, are part of the test suite
Recommends: openscad
Suggests: openscad-testing
Description: script file based graphical CAD environment (test suite data)
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 This package contains the data required to run the test suites.

Package: openscad-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    openscad (=${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends}
Description: script file based graphical CAD environment (debugging symbols)
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 This package contains debugging information stripped from the binaries.
