=== debian/watch ===
version=3

https://github.com/openscad/openscad/downloads /downloads/openscad/openscad/openscad-([0-9.]+).src.tar.gz
