=== debian/changelog ===
openscad (2013.01+dfsg-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix for bad boost libraries. (Closes: #736544)

 -- Anton Gladky <gladk@debian.org>  Fri, 24 Jan 2014 20:12:03 +0100

openscad (2013.01+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Replace libeigen2-dev by libeigen3-dev. (Closes: #726157)

 -- Anton Gladky <gladk@debian.org>  Sat, 18 Jan 2014 22:01:18 +0100

openscad (2013.01+dfsg-2) unstable; urgency=low

  * Fix eigen.pri to build on kfreebsd. (Patch by Don Bright)
  * Upload to unstable.

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sat, 23 Feb 2013 11:19:35 +0100

openscad (2013.01+dfsg-1) experimental; urgency=low

  * Added reportbug helper (includes glxinfo data in bug reports)
  * New upstream version (still to experimental, lest #673694 resurface)
    - Use the OPENSCADPATH environment variable
  * Copyright file adaptions to new files
  * Change Standards-Version to 3.9.4
    - "-b" option added to Vcs-Git
  * Removed DM-Upload-Allowed flag due to changed procedures
  * Changed watch file to googlecode

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sun, 04 Nov 2012 18:47:45 +0100

openscad (2012.05~.12-git67eb2ebe-1) experimental; urgency=low

  * Build-depend on boost modules required by new version
  * Specify GLEW include dir for tests
  * Un-apply 1b98da3f (GL/glu.h includes), fixed upstream
  * Un-apply 1cd856be (CMakeList fix), fixed upstream
  * Include upstream git snapshot
    - More configuration options for cache and performance
    - Dot product
    - Matrix multiplication
    - New search function
    - Bugfixes
  * Drop custom .desktop file and icon generation, handled upstream
  * Copyright file adaptions to new files

 -- Christian M. Amsüss <chrysn@fsfe.org>  Sat, 12 May 2012 16:52:26 +0200

openscad (2011.12-4) UNRELEASED; urgency=low

  * Acknowledge DM-Upload-Allowed: yes
  * Enable hardening flags
  * Switch to debhelper 9 to ease configuration

 -- Christian M. Amsüss <chrysn@fsfe.org>  Mon, 28 May 2012 00:13:01 +0200
