=== debian/control ===
--- 
+++ 
@@ -2,29 +2,31 @@
 Priority: optional
 Maintainer: Christian M. Amsüss <chrysn@fsfe.org>
 Build-Depends:
-    debhelper (>= 7.0.50~),
+    debhelper (>= 9),
     qt4-qmake (>=4.4),
     libcgal-dev (>=3.6),
     libopencsg-dev (>=1.3.0),
-    libeigen2-dev (>= 2.0.13),
+    libeigen3-dev,
     bison (>= 2.4),
     flex (>=2.5.35),
     libqt4-opengl-dev,
     libglew-dev (>= 1.5.4) | libglew1.6-dev | libglew1.5-dev (>= 1.5.4),
     libgmp-dev | libgmp10-dev | libgmp3-dev,
     libmpfr-dev,
-    imagemagick,
     python,
     cmake,
     libboost-dev (>= 1.46.0),
+    libboost-regex-dev,
+    libboost-system-dev,
+    libboost-filesystem-dev,
     chrpath,
-    pkg-config
-Standards-Version: 3.9.3
+    pkg-config,
+    imagemagick
+Standards-Version: 3.9.4
 Section: graphics
-DM-Upload-Allowed: yes
 Homepage: http://openscad.org/
 Vcs-Browser: http://gitorious.org/openscad-debian/openscad/commits/debian
-Vcs-git: git://gitorious.org/openscad-debian/openscad.git/
+Vcs-Git: git://gitorious.org/openscad-debian/openscad.git/ -b debian
 
 Package: openscad
 Architecture: any
@@ -56,7 +58,8 @@
     openscad-testing-data,
     python,
     python-argparse,
-    cmake
+    cmake,
+    imagemagick
 Description: script file based graphical CAD environment (test suite)
  OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
  aspects rather than artistic ones.
