=== debian/rules ===
--- 
+++ 
@@ -1,16 +1,21 @@
 #!/usr/bin/make -f
 
 # export DH_VERBOSE=1
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
 %:
 	dh $@ --parallel
 
 override_dh_auto_build:
 	dh_auto_build
 
-	convert icons/icon-alpha.png -resize 688x688 -background transparent -gravity center -extent 688x688 openscad.png
-
 	# build test suite; FIXME: why is the GLEW path not discovered automatically?
-	cd tests && cmake -DGLEW_LIBRARY=`pkg-config --variable libdir glew`/libGLEW.so -DEIGEN2_INCLUDE_DIR=`pkg-config --cflags-only-I eigen2 | sed 's/^-I//'` .
+	cd tests && CFLAGS="$$CFLAGS $$CPPFLAGS" CXXFLAGS="$$CXXFLAGS $$CPPFLAGS" cmake \
+		-DGLEW_LIBRARY=`pkg-config --variable libdir glew`/libGLEW.so \
+		-DGLEW_INCLUDE_DIR=`pkg-config --variable includedir` \
+		-DEIGEN_INCLUDE_DIR=`pkg-config --cflags-only-I eigen3 | sed 's/^-I//'` \
+		.
 	cd tests && make
 
 	# fix absolute paths in ctest scripts
