## openscad 2014.03%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -3,9 +3,13 @@
 # export DH_VERBOSE=1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+UPSTREAMVERS = $(shell dpkg-parsechangelog | sed -n 's/^Version: \([^+~]*\).*$$/\1/p')
 
 %:
 	dh $@ --parallel
+
+override_dh_auto_configure:
+	dh_auto_configure -- VERSION=$(UPSTREAMVERS)
 
 override_dh_auto_build:
 	dh_auto_build
@@ -18,17 +22,34 @@
 		.
 	cd tests && make
 
-	# fix absolute paths in ctest scripts
-	cd tests && perl -i.bak -npe 'use Cwd; my $$here = getcwd(); s/$$here/./g' *.cmake
+	# fix absolute paths in ctest scripts (relative paths will work during
+	# the build time tests, and are catered for by the openscad-testrun
+	# script).
+	cd tests && perl -i.bak -npe 'use Cwd; my $$here = getcwd(); s/\Q$$here\E/./g' *.cmake
+	# fix relative paths to plain binary names (the $PATH will be
+	# explicitly set during build time tests, and with openscad-testrun, it
+	# will have been installed).
+	cd tests && sed 's@\./\.\./openscad@openscad@' -i *.cmake
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# FIXME: ignoring the tests is not a nice thing to do, but it seems
 	# they are too much under construction atm
-	cd tests && ctest || echo "Not failing just because some tests went wrong..."
+	#
+	# PATH has to be set as the explicit ../openscad reference was removed above.
+	# OPENSCADPATH has to be set because the default library dir is
+	# determined based on the openscad binary's path (will be ok after
+	# installation).
+	cd tests && PATH=..:$$PATH OPENSCADPATH=/usr/share/openscad/libraries ctest || echo "Not failing just because some tests went wrong..."
 else
 	@echo "Skipping test suite as requested in DEB_BUILD_OPTIONS"
 endif
+
+	# fix absolute paths in generated scad files. this step logically
+	# belongs to the similar lines in the dh_auto_build override, but can
+	# first be done here becaus for the build time tests, the original
+	# paths are still required.
+	find testdata -name \*.scad  -exec perl -i.bak -npe 'use Cwd; my $$here = getcwd(); s[\Q$$here\E/tests/../testdata][/usr/share/openscad/testdata]g' {} +
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/openscad
@@ -45,15 +66,7 @@
 	# so i'll accept not getting the extra score for finding out what's
 	# wrong exactly
 	for x in \
-		cgalpngtest \
-		cgalstlsanitytest \
-		cgaltest \
-		csgtermtest \
 		csgtexttest \
-		dumptest \
-		echotest \
-		opencsgtest \
-		throwntogethertest\
 		; do chrpath -d tests/$$x; done
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
